//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <stdio.h>

#include <VarTab.h>


char *VarTab_sprintf ( _VarTab *VarTab, _VarTabFmt *VarTabFmt ) {

    //always free @ destination !!!! if (     VarTabFmt->Output ) free ( VarTabFmt->Output );
             VarTabFmt->Output = (char *)malloc ( 0xFFFF );
    memset ( VarTabFmt->Output, 0x00,             0xFFFF );

    if ( ! VarTabFmt->FieldSep  ) VarTabFmt->FieldSep  = "\n";
    if ( ! VarTabFmt->StringSep ) VarTabFmt->StringSep =  "'";

    if ( VarTabFmt->Mode & VarTabFmtSQL ) {
	VarTabFmt->FieldSep  = ",";
	VarTabFmt->StringSep = "'";
    }

char  oFmt[25];
int VarTab_pos = 0;
    VarTab_pos = 0;
    while ( VarTab[VarTab_pos].Name ) {
	//printf ( "VarTab[%d].Name=%s\n"   , VarTab_pos, VarTab[VarTab_pos].Name    );
	//printf ( "VarTab[%d].Size=%ld\n"  , VarTab_pos, VarTab[VarTab_pos].Size    );
	//printf ( "VarTab[%d].Pointer=%c\n", VarTab_pos, VarTab[VarTab_pos].Pointer );
	//printf ( "VarTab[%d].Type=%s\n"   , VarTab_pos, VarTab[VarTab_pos].Type    );
	//printf ( "VarTab[%d].Address=%p\n", VarTab_pos, VarTab[VarTab_pos].Address );

	if ( VarTab_pos ) strcat ( VarTabFmt->Output, VarTabFmt->FieldSep );
    //FieldName
	if ( VarTabFmt->Mode & VarTabFmtName )
	    sprintf ( VarTabFmt->Output, "%s%s=", VarTabFmt->Output, VarTab[VarTab_pos].Name );

	if ( 1 == 0 ) {}
	else if ( strcmp ( "long", VarTab[VarTab_pos].Type) == 0 ) {
	long *x = (long *)VarTab[VarTab_pos].Address;
	    if ( ! VarTab[VarTab_pos].Format ) VarTab[VarTab_pos].Format = "%ld";
	    sprintf ( oFmt, "%%s%s", VarTab[VarTab_pos].Format );
	    sprintf ( VarTabFmt->Output, oFmt, VarTabFmt->Output, *x );
	}//else if ( strcmp ( "long", VarTab[VarTab_pos].Type) == 0 )
	else if ( strcmp ( "double", VarTab[VarTab_pos].Type ) == 0 ) {
	double *x = (double *)VarTab[VarTab_pos].Address;
	    if ( ! VarTab[VarTab_pos].Format ) VarTab[VarTab_pos].Format = "%0.2f";
	    sprintf ( oFmt, "%%s%s", VarTab[VarTab_pos].Format );
	    sprintf ( VarTabFmt->Output, oFmt, VarTabFmt->Output, *x );
	}//else if ( strcmp ( "long", VarTab[VarTab_pos].Type) == 0 )
	else if ( strcmp ( "char", VarTab[VarTab_pos].Type ) == 0 ) {
	char *x = (char *)VarTab[VarTab_pos].Address;
	    if ( !      VarTab[VarTab_pos].Format  ) { VarTab[VarTab_pos].Format = "%s"; }
	    if (  1  == VarTab[VarTab_pos].Size    ) { VarTab[VarTab_pos].Format = "%c"; VarTabFmt->StringSep = ""; }
	    if ( '*' == VarTab[VarTab_pos].Pointer ) { VarTab[VarTab_pos].Format = "%p"; VarTabFmt->StringSep = ""; };
	    sprintf ( oFmt, "%%s%s%s%s",VarTabFmt->StringSep, VarTab[VarTab_pos].Format, VarTabFmt->StringSep );
	    if (  1  == VarTab[VarTab_pos].Size    )
		sprintf ( VarTabFmt->Output, oFmt, VarTabFmt->Output, *x );
	    else
		sprintf ( VarTabFmt->Output, oFmt, VarTabFmt->Output,  x );
	}//else if ( strcmp ( "long", VarTab[VarTab_pos].Type) == 0 )
	else {
	    sprintf ( VarTabFmt->Output, "%s%s", VarTabFmt->Output, "error" );
	}
	//printf ( "oFmt=~%s~\n", oFmt );
	VarTab_pos++;
    }//while ( VarTab[VarTab_pos].Name )
    //printf ( "VarTabFmt->Mode=%02X\n", VarTabFmt->Mode );

    return VarTabFmt->Output;

}//char *VarTab_sprintf ( _VarTab *VarTab, _VarTabFmt *VarTabFmt )
