//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifndef _ebus_H
#define _ebus_H

#include <string>
#include <vector>

using namespace std;

#include <socket_tcp.h>


class _ebus {
public:
    char *Loop  ( void );
    char *Close ( void );

    char  Error[1024];
             char  *Host;
    unsigned short  Port;
    char  txCmd[1024];
    char  rxCmd[1024];
    char  InitDone;
    char  Status;
    long  Timeout;
    long *Now;
    int   CmdCnt;
    long *Index;
    long *IdxSelf;
    _socket_tcp socClient;
    _ebus () {
	Error[0] =    0;
	Host     = NULL;
	Port     =    0;
	txCmd[0] =    0;
	rxCmd[0] =    0;
	InitDone =    0;
	Status   =    0;
	Timeout  =    0;
	Now      = NULL;
	CmdCnt   =    0;
	Index    = NULL;
	IdxSelf  = NULL;
    }

};


class _ebuss {
public:
    char *Loop  ( void );
    char *Close ( void );
    char *Set   ( long *Idx, const std::string &Key, long *KeyIdx, const std::string &Val );

    char  Error[1024];
    long  *Now;
    char  Status;
    vector<_ebus> ebus;
    _ebuss () {
	Error[0] =    0;
	Now      = NULL;
	Status   =    0;
    }

};


#endif
