//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//#define	DEBUG
#include <stdio.h>

#include <String.h>
#include <albus_log.h>

#include <heat_master.h>
#include <heat_masterd.h>
#include "heat_master_server.h"


extern vector <_HeatMasterMap> vHtmlMap;
extern _heat_master heat_master;
extern char   home[];
extern string ShowSQLName;
extern string ShowSQL;
extern long   intervall;
extern char   bin_home[];


char *_heat_master_server::Close( void ) {
PFLID
//2do
    return NULL;

}//char *_heat_master_server::Close( void )


char *_heat_master_server::Loop ( void ) {
PFLID
    if ( Error[0] ) return NULL;

    if ( ! InitDone ) {
	InitDone = 1;
	socket_tcp.Listen = 1;//server
	socket_tcp.Host   = host;
	socket_tcp.Port   = port;
	for ( int fd_pos = 0; fd_pos < fd_stack_max; fd_pos++ ) {
	    //D8 ("fd_pos=%d", fd_pos );
	_fd_stack *fd_stack_new = &socket_tcp.fd_stack[fd_pos];
	    fd_stack_new->rx.malloc = 0x1FF;
	    fd_stack_new->rx.data = (unsigned char *)malloc ( fd_stack_new->rx.malloc );
	    fd_stack_new->tx.malloc = 0xFFFFF;
	    fd_stack_new->tx.data = (unsigned char *)malloc ( fd_stack_new->tx.malloc );
	}
	socket_tcp.Loop (); sleep (1); return NULL;//start server
    }//if ( ! InitDone )

    for ( int fd_pos = 0; fd_pos < fd_stack_max; fd_pos++ ) {
	//D8 ("fd_pos=%d", fd_pos );
    _fd_stack *fd_stack_new = &socket_tcp.fd_stack[fd_pos];
	if ( fd_stack_new->rx.len ) {
	    fd_stack_new->Close = 0;
	    D9 ( "sv_rx[%03d]=~%s~\n", fd_pos, fd_stack_new->rx.data );
	char *rx_data = (char *)fd_stack_new->rx.data;
	    fd_stack_new->rx.len = 0;
	    memset ( fd_stack_new->tx.data, 0, fd_stack_new->tx.malloc );
	char *tx_data = (char *)fd_stack_new->tx.data;

	    if ( 1 == 0 ) {}
	    else if ( strncmp ( "exit", rx_data, strlen ( "exit" ) ) == 0 ) {
		sprintf ( tx_data, "good by\n" );
		fd_stack_new->Close = 1;
	    }
	    else if ( strncmp ( "GET /favicon.ico", rx_data, strlen ( "GET /favicon.ico" ) ) == 0 ) {
		HTTP_favicon  ( fd_stack_new );
	    }
	    else if ( strncmp ( "GET ", rx_data, strlen ( "GET " ) ) == 0 ) {
		HTTP  ( fd_stack_new );
	    }
	    else {
		sprintf ( tx_data, "%s", ShowSQLName.c_str() );
		fd_stack_new->tx.len = strlen ( tx_data );
	    }
	}//if ( fd_stack_new->rx.len )
    }//for ( int fd_pos = 0; fd_pos < fd_stack_max; fd_pos++ )

    return socket_tcp.Loop ();

}//char *_heat_master_server::Loop ( void )


char *_heat_master_server::HTTP ( _fd_stack *fd_stack_new ) {

string URL      = "localhost";

string rxHeader = (char *)fd_stack_new->rx.data;
    Replace ( rxHeader, "\r", "" );
    D9 ( "rxHeader=~%s~", rxHeader.c_str() );

    Replace ( rxHeader, ":", "=" );
vector<_KeyIdxVal> KeyIdxVal = String2KeyIdxVal ( rxHeader );
int KeyIdxValPos = 0;
    while ( KeyIdxValPos < KeyIdxVal.size() ) {
	D9 ( "KeyIdxVal[%d].Key=~%s~ Val=~%s~", KeyIdxValPos, KeyIdxVal[KeyIdxValPos].Key.c_str(), KeyIdxVal[KeyIdxValPos].Val.c_str() );
	if ( 1 == 0 ) {}
	else if ( "Host"    == KeyIdxVal[KeyIdxValPos].Key ) {
	    URL = KeyIdxVal[KeyIdxValPos].Val;
	    Replace ( URL, "=", ":" );
	}
	KeyIdxValPos++;
    }//while ( KeyIdxValPos < KeyIdxVal.size() )

    //2do URL += "?a=c";

string Content;
string ContentType;
    ContentType = "Content-Type: text/html\r\n\r\n";
    Content  = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
    Content += "<html>\n";
    Content += "<head>\n";
    Content += " <title>bn-heat_master</title>\n";
long Refresh = intervall / 2;
    if ( 5 > Refresh ) Refresh = 5;
char sRefresh[20];
    sprintf ( sRefresh, "%d", Refresh );
    Content += " <meta HTTP-EQUIV=\"Refresh\" CONTENT=\"";
    Content += sRefresh;
    Content += "; URL=http://" + URL + "\" >\n";
    Content += "</head>\n";
    Content += "<body>\n";
    Content += "<table border=0 cellspacing=1 bgcolor=#A0A0A0>\n";
    Content += "<tr bgcolor=00FF00>\n";
    for ( long mPos = 0; mPos < vHtmlMap.size(); mPos++ ) {
	Content += "<td>" + vHtmlMap[mPos].dstField + "</td>\n";
    }//for ( long mPos = 0; mPos < vHtmlMap.size(); mPos++ )
    Content += "</tr>\n";

vector<string> Files = ReadDir( home, 0, RD_NAME | RD_DESC );
    D9 ( "Files.size() = %d", Files.size() );
string fSkip = "last.txt";
    for ( long DirPos = 0; DirPos < Files.size(); DirPos++ ) {
	D9 ( "Files[%03d] = ~%s~", DirPos, Files[DirPos].c_str() );

    string  oFile  = home;
	    oFile += "/" + Files[DirPos];

	if ( -1 != oFile.find( fSkip ) ) continue;
	D9 ( "oFile = ~%s~", oFile.c_str() );

    string fData = File2String ( oFile );
	if ( 10 > fData.length() ) continue;
	D9 ( "fData = ~%s~", fData.c_str() );

    vector<string> Field = Split ( fData, ',' );
	D9 ( "Field.size() = %d", Field.size() );

	for ( long FieldPos = 0; FieldPos < Field.size(); FieldPos++ ) {
	    Replace ( Field[FieldPos], "\'", "" );
	}

	Content += "<tr bgcolor=FFFFFF>\n";
	for ( long mPos = 0; mPos < vHtmlMap.size(); mPos++ ) {
	    D9 ( "vHtmlMap.srcField=~%s~", vHtmlMap[mPos].srcField.c_str() );
	vector<string> src = Split ( vHtmlMap[mPos].srcField, ';' );
	    if ( ! src.size() ) continue;

	    for ( long srcPos = 0; srcPos < src.size(); srcPos++ ) {
		Replace ( src[srcPos], " ", "" );
	    }

	int *fPos = NULL;
	int VarTab_pos = 0;
	    while ( heat_master.VarTab[VarTab_pos].Name ) {
		D9 ( "VarTab[%d].Name=%s", VarTab_pos, heat_master.VarTab[VarTab_pos].Name );
		if ( heat_master.VarTab[VarTab_pos].Name == src[0] ) {
		    fPos = &VarTab_pos;
		    break;
		}
		VarTab_pos++;
	    }
	    if ( ! fPos ) continue;
	    VarTab_pos = *fPos;
	    D9 ( "*fPos=%d", *fPos );

	string o1 = Field[*fPos];
	char *Type = heat_master.VarTab[VarTab_pos].Type;
	    D9 ( "Type=%s", Type );

	    for ( long srcPos = 1; srcPos < src.size(); srcPos++ ) {
		D9 ( "src[%d]=~%s~", srcPos, src[srcPos].c_str() );
		if ( 1 == 0 ) {}
		else if ( "usec2string()" == src[srcPos] ) {
		    o1 = usec2string(o1);
		    Type = (char *)"char";
		}
	    }//for ( long srcPos = 1; srcPos < src.size(); srcPos++ )
	string tdFmt = "";
	    if ( 1 == 0 ) {}
	    else if ( strcmp ( "long"  , Type ) == 0 ) tdFmt = "align=right";
	    else if ( strcmp ( "double", Type ) == 0 ) tdFmt = "align=right";

	    Content += "<td "+tdFmt+">" + o1  + "</td>\n";

	}//for ( long mPos = 0; mPos < vHtmlMap.size(); mPos++ )

	Content += "</tr>\n";

	if ( 24 * 60 == DirPos ) break;
	//break;//bug4debug
    }//for ( long DirPos = 0; DirPos < Files.size(); DirPos++ )

    Content += "</table>\n";
    Content += "</body>\n";
    //D8 ( "Content=~%s~", Content.c_str() );

    //D9 ( "fd_stack_new->tx.malloc=%08X", fd_stack_new->tx.malloc );
    if ( fd_stack_new->tx.malloc <= Content.length() ) {//2do send blocks
	Content = "malloc <= Content.length()";
    }

char Content_Length[50] = "";
    sprintf ( Content_Length, "Content-Length: %d\r\n", Content.length() );
string txHeader;
    txHeader  = "HTTP/1.1 200 OK\r\n";
    //txHeader += "Date: Mon, 28 Dec 2015 07:10:59 GMT\r\n";
    //txHeader += "Server: Apache/2.2.22 (Debian)\r\n";
    //txHeader += "Last-Modified: Mon, 28 Dec 2015 07:08:13 GMT\r\n";
    //txHeader += "Accept-Ranges: bytes\r\n";
    txHeader += Content_Length;
    //txHeader += "Vary: Accept-Encoding\r\n";
    txHeader += "Keep-Alive: timeout=5, max=100\r\n";
    txHeader += "Connection: Keep-Alive\r\n";
    //txHeader += "Content-Type: text/plain\r\n\r\n"; mime
    txHeader += ContentType;

    D9 ( "txHeader=~%s~", txHeader.c_str() );
    D9 ( "Content=~%s~" , Content.c_str()  );

char *tx_data = (char *)fd_stack_new->tx.data;
    sprintf ( tx_data, "%s%s", txHeader.c_str(), Content.c_str() );
    fd_stack_new->tx.len = strlen ( tx_data );
    //fd_stack_new->Close = 1;
    return NULL;

}//char *_heat_master_server::HTTP  ( _fd_stack *fd_stack_new )


char *_heat_master_server::HTTP_favicon ( _fd_stack *fd_stack_new ) {

string ContentType;
string txHeader;

_socket_blob bContenT;
             bContenT.malloc = 1024;//2do
             bContenT.data = (unsigned char *)malloc( bContenT.malloc );
    memset ( bContenT.data, 0x00, bContenT.malloc );

string  fName  = bin_home;
	fName += "/../http";
	fName += "/favicon.ico";
FILE *fFile = fopen ( fName.c_str(), "rb" );
    if ( fFile ) {
	bContenT.len = fread ( bContenT.data, 1, bContenT.malloc, fFile );
	fclose ( fFile );
	D9 ( "bContenT.len=%d", bContenT.len );
	txHeader  = "HTTP/1.1 200 OK\r\n";
	ContentType = "Content-Type: image/x-icon\r\n\r\n";
    }
    else {
    char *aContent = (char *)bContenT.data;
	strcat ( aContent, "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">\r\n" );
	strcat ( aContent, "<html>\r\n" );
	strcat ( aContent, "<head><title>404 Not Found</title></head>\r\n" );
	strcat ( aContent, "<body>\r\n" );
	strcat ( aContent, "<h1>Not Found</h1>\r\n" );
	strcat ( aContent, "<p>The requested URL /favicon.ico was not found on this server.</p>\r\n" );
	strcat ( aContent, "</body>\r\n" );
	strcat ( aContent, "</html>\r\n" );
	ER ( "The requested URL /favicon.ico was not found on this server" );
	Error[0] = 0;
	bContenT.len = strlen ( aContent );
	txHeader     = "HTTP/1.1 404 Not Found\r\n";
	ContentType  = "Content-Type: text/html\r\n\r\n";
    }

char Content_Length[50] = "";
    sprintf ( Content_Length, "Content-Length: %d\r\n", bContenT.len );
    txHeader += Content_Length;
    txHeader += "Keep-Alive: timeout=5, max=100\r\n";
    txHeader += "Connection: Keep-Alive\r\n";
    txHeader += ContentType;
    D9 ( "txHeader=~%s~", txHeader.c_str() );

    memcpy  ( fd_stack_new->tx.data                    , txHeader.c_str(), txHeader.length() );
    memcpy  ( fd_stack_new->tx.data + txHeader.length(), bContenT.data   , bContenT.len      );//2do tx.data.malloc > bContenT.malloc
	      fd_stack_new->tx.len  = txHeader.length() + bContenT.len;
    free ( bContenT.data );

    return NULL;

}//char *_heat_master_server::HTTP_favicon ( _fd_stack *fd_stack_new )
