//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifndef _heat_master_server_H
#define _heat_master_server_H

#include <socket_tcp.h>


class _heat_master_server {
public:
    char *Loop  ( void );
    char *Close ( void );
    char *HTTP  ( _fd_stack *fd_stack_new );
    char *HTTP_favicon ( _fd_stack *fd_stack_new );
    char  Error[1024];
    char               *host;
    unsigned short      port;
    char  txCmd[1024];
    char  rxCmd[1024];
    char  InitDone;
    char  Status;
    _socket_tcp socket_tcp;
    _heat_master_server () {
	Error[0] = 0;
	host     = NULL;
	port     = 0;
	txCmd[0] = 0;
	rxCmd[0] = 0;
	InitDone = 0;
	Status   = 0;
    }

};

#endif
