#ifndef _heat_master_H
#define _heat_master_H


#include <string.h>
#include <stdlib.h>
#include <VarTab.h>


class _heat_master {
public:
	long  id;
	long  usec;
	long  eb_usec;
	double  eb_t1;
	double  eb_t2;
	double  eb_t3;
	char  eb_mode[50];
	long  dl_dev_id;
	long  dl_usec;
	double  dl_t1;
	double  dl_t2;
	double  dl_t3;
	double  dl_t4;
	double  dl_t5;
	double  dl_t6;
	long  dl_a1;
	long  dl_a2;
	long  dl_a3;
	long  ab_a1;
	long  ab_a2;
	long  ab_a3;
	long  ab_a4;
	char  error[255];
	char  host[50];

	_VarTab    VarTab[25];
	_VarTabFmt VarTabFmt;

    void Clean ( void ) {
	memset ( this, 0x00, sizeof ( _heat_master ) );
	VarTab[0].Name = (char *)"id"; VarTab[0].Type = (char *)"long"; VarTab[0].Address = (void *)&id; VarTab[0].Format = NULL; VarTab[0].Size = sizeof ( long   ); VarTab[0].Pointer = ' ';
	VarTab[1].Name = (char *)"usec"; VarTab[1].Type = (char *)"long"; VarTab[1].Address = (void *)&usec; VarTab[1].Format = NULL; VarTab[1].Size = sizeof ( long   ); VarTab[1].Pointer = ' ';
	VarTab[2].Name = (char *)"eb_usec"; VarTab[2].Type = (char *)"long"; VarTab[2].Address = (void *)&eb_usec; VarTab[2].Format = NULL; VarTab[2].Size = sizeof ( long   ); VarTab[2].Pointer = ' ';
	VarTab[3].Name = (char *)"eb_t1"; VarTab[3].Type = (char *)"double"; VarTab[3].Address = (void *)&eb_t1; VarTab[3].Format = (char *)"%0.1f"; VarTab[3].Size = sizeof ( double   ); VarTab[3].Pointer = ' ';
	VarTab[4].Name = (char *)"eb_t2"; VarTab[4].Type = (char *)"double"; VarTab[4].Address = (void *)&eb_t2; VarTab[4].Format = (char *)"%0.1f"; VarTab[4].Size = sizeof ( double   ); VarTab[4].Pointer = ' ';
	VarTab[5].Name = (char *)"eb_t3"; VarTab[5].Type = (char *)"double"; VarTab[5].Address = (void *)&eb_t3; VarTab[5].Format = (char *)"%0.1f"; VarTab[5].Size = sizeof ( double   ); VarTab[5].Pointer = ' ';
	VarTab[6].Name = (char *)"eb_mode"; VarTab[6].Type = (char *)"char"; VarTab[6].Address = (void *)&eb_mode; VarTab[6].Format = NULL; VarTab[6].Size = sizeof ( char   ) * 50; VarTab[6].Pointer = ' ';
	VarTab[7].Name = (char *)"dl_dev_id"; VarTab[7].Type = (char *)"long"; VarTab[7].Address = (void *)&dl_dev_id; VarTab[7].Format = NULL; VarTab[7].Size = sizeof ( long   ); VarTab[7].Pointer = ' ';
	VarTab[8].Name = (char *)"dl_usec"; VarTab[8].Type = (char *)"long"; VarTab[8].Address = (void *)&dl_usec; VarTab[8].Format = NULL; VarTab[8].Size = sizeof ( long   ); VarTab[8].Pointer = ' ';
	VarTab[9].Name = (char *)"dl_t1"; VarTab[9].Type = (char *)"double"; VarTab[9].Address = (void *)&dl_t1; VarTab[9].Format = (char *)"%0.1f"; VarTab[9].Size = sizeof ( double   ); VarTab[9].Pointer = ' ';
	VarTab[10].Name = (char *)"dl_t2"; VarTab[10].Type = (char *)"double"; VarTab[10].Address = (void *)&dl_t2; VarTab[10].Format = (char *)"%0.1f"; VarTab[10].Size = sizeof ( double   ); VarTab[10].Pointer = ' ';
	VarTab[11].Name = (char *)"dl_t3"; VarTab[11].Type = (char *)"double"; VarTab[11].Address = (void *)&dl_t3; VarTab[11].Format = (char *)"%0.1f"; VarTab[11].Size = sizeof ( double   ); VarTab[11].Pointer = ' ';
	VarTab[12].Name = (char *)"dl_t4"; VarTab[12].Type = (char *)"double"; VarTab[12].Address = (void *)&dl_t4; VarTab[12].Format = (char *)"%0.1f"; VarTab[12].Size = sizeof ( double   ); VarTab[12].Pointer = ' ';
	VarTab[13].Name = (char *)"dl_t5"; VarTab[13].Type = (char *)"double"; VarTab[13].Address = (void *)&dl_t5; VarTab[13].Format = (char *)"%0.1f"; VarTab[13].Size = sizeof ( double   ); VarTab[13].Pointer = ' ';
	VarTab[14].Name = (char *)"dl_t6"; VarTab[14].Type = (char *)"double"; VarTab[14].Address = (void *)&dl_t6; VarTab[14].Format = (char *)"%0.1f"; VarTab[14].Size = sizeof ( double   ); VarTab[14].Pointer = ' ';
	VarTab[15].Name = (char *)"dl_a1"; VarTab[15].Type = (char *)"long"; VarTab[15].Address = (void *)&dl_a1; VarTab[15].Format = NULL; VarTab[15].Size = sizeof ( long   ); VarTab[15].Pointer = ' ';
	VarTab[16].Name = (char *)"dl_a2"; VarTab[16].Type = (char *)"long"; VarTab[16].Address = (void *)&dl_a2; VarTab[16].Format = NULL; VarTab[16].Size = sizeof ( long   ); VarTab[16].Pointer = ' ';
	VarTab[17].Name = (char *)"dl_a3"; VarTab[17].Type = (char *)"long"; VarTab[17].Address = (void *)&dl_a3; VarTab[17].Format = NULL; VarTab[17].Size = sizeof ( long   ); VarTab[17].Pointer = ' ';
	VarTab[18].Name = (char *)"ab_a1"; VarTab[18].Type = (char *)"long"; VarTab[18].Address = (void *)&ab_a1; VarTab[18].Format = NULL; VarTab[18].Size = sizeof ( long   ); VarTab[18].Pointer = ' ';
	VarTab[19].Name = (char *)"ab_a2"; VarTab[19].Type = (char *)"long"; VarTab[19].Address = (void *)&ab_a2; VarTab[19].Format = NULL; VarTab[19].Size = sizeof ( long   ); VarTab[19].Pointer = ' ';
	VarTab[20].Name = (char *)"ab_a3"; VarTab[20].Type = (char *)"long"; VarTab[20].Address = (void *)&ab_a3; VarTab[20].Format = NULL; VarTab[20].Size = sizeof ( long   ); VarTab[20].Pointer = ' ';
	VarTab[21].Name = (char *)"ab_a4"; VarTab[21].Type = (char *)"long"; VarTab[21].Address = (void *)&ab_a4; VarTab[21].Format = NULL; VarTab[21].Size = sizeof ( long   ); VarTab[21].Pointer = ' ';
	VarTab[22].Name = (char *)"error"; VarTab[22].Type = (char *)"char"; VarTab[22].Address = (void *)&error; VarTab[22].Format = NULL; VarTab[22].Size = sizeof ( char   ) * 255; VarTab[22].Pointer = ' ';
	VarTab[23].Name = (char *)"host"; VarTab[23].Type = (char *)"char"; VarTab[23].Address = (void *)&host; VarTab[23].Format = NULL; VarTab[23].Size = sizeof ( char   ) * 50; VarTab[23].Pointer = ' ';

    }//void Clean ( void )

    _heat_master () {
	Clean ();
    }//Constructor

    char *sprintf ( void ) { return VarTab_sprintf ( (_VarTab *)&VarTab, &VarTabFmt ); }

};

#endif
