//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>

using namespace std;

vector<string> Split ( const string &s, char delim );
void           Replace ( std::string &str, const std::string &strOut, const std::string& str_In );
string         File2String ( string &File );

class _KeyIdxVal {
public:
    string  Key;
    long   *Idx;
    string  Val;
    _KeyIdxVal () {
	Key =   "";
	Idx = NULL;
	Val =   "";
    }
    _KeyIdxVal ( const string &Line );
};
vector<_KeyIdxVal> String2KeyIdxVal ( string &rxString );
void ReplaceWhiteSpace ( std::string &str );
vector<string> ReadDir ( const string &rDir, long rFlags, long rSort );
#define        RD_NAME 0x0001
#define        RD_DESC 0x8000

string usec2string ( string sSec );
string usec2string ( long   lSec );
