//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifdef __cplusplus
extern "C" {
#endif

#ifndef _VarTab_H
#define _VarTab_H

#include <string.h>
#include <stdlib.h>

#define VarTabFmtName 0x01
#define VarTabFmtSQL  0x80


typedef struct {
         void *Address;
         char *Name;
unsigned long  Size;
         char *Type;
         char  Pointer;
         char *Format;
} _VarTab;


typedef struct {
         char *Output;
unsigned char  Mode;
         char *FieldSep;
         char *StringSep;
} _VarTabFmt;


char *VarTab_sprintf ( _VarTab *VarTab, _VarTabFmt *VarTabFmt );


#endif

#ifdef __cplusplus
}
#endif
