//Copyright 2016 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <albus_log.h>
#include <heat_master.h>


extern _heat_master        heat_master;

double  Buffer    = 0;
double  Solar     = 0;
double  SolarIn   = 0;
double  SolarOut  = 0;
long    SolarPump = 0;


char *logic_Loop ( void ) {
PFLID

    Buffer    = heat_master.eb_t2;
    Solar     = heat_master.dl_t1;
    SolarIn   = heat_master.dl_t4;
    SolarOut  = heat_master.dl_t2;

    D8( "Buffer    =%f",  Buffer    );
    D8( "Solar     =%f",  Solar     );
    D8( "SolarIn   =%f",  SolarIn   );
    D8( "SolarOut  =%f",  SolarOut  );
    D8( "SolarPump =%d",  SolarPump );

    if ( ! SolarPump ) {
	if ( Buffer + 5 < Solar ) {
	    D1("Pump ON");
	    SolarPump = 1;
	}
    }
    else {
	if ( SolarOut > SolarIn - 5 ) {
	    D1("PumpOFF");
	    SolarPump = 0;
	}
    }

//2do time stall
    if ( ! heat_master.eb_usec ) SolarPump = 0;
    if ( ! heat_master.dl_usec ) SolarPump = 0;

    D8( "SolarPump =%d",  SolarPump );
long *SolarPumpX = NULL;
      SolarPumpX = &heat_master.ab_a1;
     *SolarPumpX = SolarPump;

    return NULL;

}//char *logic_Loop ( void )
